Index: branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs
===================================================================
--- branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 9292)
+++ branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 9732)
@@ -31,13 +31,21 @@
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
   [StorableClass]
-  [Item("SymbolicDataAnalysisExpressionTreeLinearInterpreter", "Interpreter for symbolic expression trees including automatically defined functions.")]
-  public class SymbolicDataAnalysisExpressionTreeLinearInterpreter : ParameterizedNamedItem, ISymbolicDataAnalysisExpressionTreeInterpreter {
+  [Item("SymbolicDataAnalysisExpressionTreeFastInterpreter",
+    "Fast interpreter for symbolic expression trees including automatically defined functions.")]
+  public class SymbolicDataAnalysisExpressionTreeFastInterpreter : ParameterizedNamedItem,
+                                                                   ISymbolicDataAnalysisExpressionTreeInterpreter {
     private const string CheckExpressionsWithIntervalArithmeticParameterName = "CheckExpressionsWithIntervalArithmetic";
     private const string EvaluatedSolutionsParameterName = "EvaluatedSolutions";
 
-    public override bool CanChangeName { get { return false; } }
-    public override bool CanChangeDescription { get { return false; } }
+    public override bool CanChangeName {
+      get { return false; }
+    }
+
+    public override bool CanChangeDescription {
+      get { return false; }
+    }
 
     #region parameter properties
+
     public IValueParameter<BoolValue> CheckExpressionsWithIntervalArithmeticParameter {
       get { return (IValueParameter<BoolValue>)Parameters[CheckExpressionsWithIntervalArithmeticParameterName]; }
@@ -47,7 +55,9 @@
       get { return (IValueParameter<IntValue>)Parameters[EvaluatedSolutionsParameterName]; }
     }
+
     #endregion
 
     #region properties
+
     public BoolValue CheckExpressionsWithIntervalArithmetic {
       get { return CheckExpressionsWithIntervalArithmeticParameter.Value; }
@@ -59,23 +69,41 @@
       set { EvaluatedSolutionsParameter.Value = value; }
     }
+
     #endregion
 
     [StorableConstructor]
-    protected SymbolicDataAnalysisExpressionTreeLinearInterpreter(bool deserializing) : base(deserializing) { }
-    protected SymbolicDataAnalysisExpressionTreeLinearInterpreter(SymbolicDataAnalysisExpressionTreeLinearInterpreter original, Cloner cloner) : base(original, cloner) { }
+    protected SymbolicDataAnalysisExpressionTreeFastInterpreter(bool deserializing)
+      : base(deserializing) {
+    }
+
+    protected SymbolicDataAnalysisExpressionTreeFastInterpreter(
+      SymbolicDataAnalysisExpressionTreeFastInterpreter original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new SymbolicDataAnalysisExpressionTreeLinearInterpreter(this, cloner);
-    }
-
-    public SymbolicDataAnalysisExpressionTreeLinearInterpreter()
-      : base("SymbolicDataAnalysisExpressionTreeLinearInterpreter", "Interpreter for symbolic expression trees including automatically defined functions.") {
-      Parameters.Add(new ValueParameter<BoolValue>(CheckExpressionsWithIntervalArithmeticParameterName, "Switch that determines if the interpreter checks the validity of expressions with interval arithmetic before evaluating the expression.", new BoolValue(false)));
-      Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName, "A counter for the total number of solutions the interpreter has evaluated", new IntValue(0)));
-    }
-
-    protected SymbolicDataAnalysisExpressionTreeLinearInterpreter(string name, string description)
+      return new SymbolicDataAnalysisExpressionTreeFastInterpreter(this, cloner);
+    }
+
+    public SymbolicDataAnalysisExpressionTreeFastInterpreter()
+      : base(
+        "SymbolicDataAnalysisExpressionTreeFastInterpreter",
+        "Interpreter for symbolic expression trees including automatically defined functions.") {
+      Parameters.Add(new ValueParameter<BoolValue>(CheckExpressionsWithIntervalArithmeticParameterName,
+                                                   "Switch that determines if the interpreter checks the validity of expressions with interval arithmetic before evaluating the expression.",
+                                                   new BoolValue(false)));
+      Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName,
+                                                  "A counter for the total number of solutions the interpreter has evaluated",
+                                                  new IntValue(0)));
+    }
+
+    protected SymbolicDataAnalysisExpressionTreeFastInterpreter(string name, string description)
       : base(name, description) {
-      Parameters.Add(new ValueParameter<BoolValue>(CheckExpressionsWithIntervalArithmeticParameterName, "Switch that determines if the interpreter checks the validity of expressions with interval arithmetic before evaluating the expression.", new BoolValue(false)));
-      Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName, "A counter for the total number of solutions the interpreter has evaluated", new IntValue(0)));
+      Parameters.Add(new ValueParameter<BoolValue>(CheckExpressionsWithIntervalArithmeticParameterName,
+                                                   "Switch that determines if the interpreter checks the validity of expressions with interval arithmetic before evaluating the expression.",
+                                                   new BoolValue(false)));
+      Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName,
+                                                  "A counter for the total number of solutions the interpreter has evaluated",
+                                                  new IntValue(0)));
     }
 
@@ -83,8 +111,11 @@
     private void AfterDeserialization() {
       if (!Parameters.ContainsKey(EvaluatedSolutionsParameterName))
-        Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName, "A counter for the total number of solutions the interpreter has evaluated", new IntValue(0)));
+        Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName,
+                                                    "A counter for the total number of solutions the interpreter has evaluated",
+                                                    new IntValue(0)));
     }
 
     #region IStatefulItem
+
     public void InitializeState() {
       EvaluatedSolutions.Value = 0;
@@ -93,9 +124,12 @@
     public void ClearState() {
     }
+
     #endregion
 
-    public IEnumerable<double> GetSymbolicExpressionTreeValues(ISymbolicExpressionTree tree, Dataset dataset, IEnumerable<int> rows) {
+    public IEnumerable<double> GetSymbolicExpressionTreeValues(ISymbolicExpressionTree tree, Dataset dataset,
+                                                               IEnumerable<int> rows) {
       if (CheckExpressionsWithIntervalArithmetic.Value)
-        throw new NotSupportedException("Interval arithmetic is not yet supported in the symbolic data analysis interpreter.");
+        throw new NotSupportedException(
+          "Interval arithmetic is not yet supported in the symbolic data analysis interpreter.");
 
       lock (EvaluatedSolutions) {
@@ -103,6 +137,33 @@
       }
 
-      Instruction[] code = SymbolicExpressionTreeCompiler.CompilePostfix(tree, OpCodes.MapSymbolToOpCode);
-      foreach (Instruction instr in code) {
+      var root = tree.Root.GetSubtree(0).GetSubtree(0);
+      var nodes = new List<ISymbolicExpressionTreeNode> { root };
+      var code = new List<Instruction>{ 
+        new Instruction { dynamicNode = root,
+        nArguments = (byte) root.SubtreeCount, 
+        opCode = OpCodes.MapSymbolToOpCode(root)
+        }
+      };
+
+      // iterate breadth-wise over tree nodes and produce an array of instructions
+      int i = 0;
+      while (i != nodes.Count) {
+        if (nodes[i].SubtreeCount > 0) {
+          // save index of the first child in the instructions array
+          code[i].childIndex = code.Count;
+          for (int j = 0; j != nodes[i].SubtreeCount; ++j) {
+            var s = nodes[i].GetSubtree(j);
+            nodes.Add(s);
+            code.Add(new Instruction {
+              dynamicNode = s,
+              nArguments = (byte)s.SubtreeCount,
+              opCode = OpCodes.MapSymbolToOpCode(s)
+            });
+          }
+        }
+        ++i;
+      }
+      // fill in iArg0 value for terminal nodes
+      foreach (var instr in code) {
         switch (instr.opCode) {
           case OpCodes.Variable: {
@@ -124,127 +185,115 @@
       }
 
+      var array = code.ToArray();
+
       foreach (var rowEnum in rows) {
         int row = rowEnum;
-        yield return Evaluate(dataset, ref row, code);
+        EvaluateFast(dataset, ref row, array);
+        yield return code[0].value;
       }
     }
 
-    protected virtual double Evaluate(Dataset dataset, ref int row, Instruction[] code) {
-      int count = 0;
-      for (int j = 0; j != code.Length; ++j) {
-        Instruction currentInstr = code[j];
-	int narg = currentInstr.nArguments;
-
-        switch (currentInstr.opCode) {
+    private void EvaluateFast(Dataset dataset, ref int row, Instruction[] code) {
+      for (int i = code.Length - 1; i >= 0; --i) {
+        var instr = code[i];
+
+        switch (instr.opCode) {
           case OpCodes.Add: {
-              double s = code[j - narg].value;
-              for (int i = j - narg + 1; i < j; i++) {
-                s += code[i].value;
-              }
-              currentInstr.value = s;
+              double s = code[instr.childIndex].value;
+              for (int j = 1; j != instr.nArguments; ++j) {
+                s += code[instr.childIndex + j].value;
+              }
+              instr.value = s;
             }
             break;
           case OpCodes.Sub: {
-              double s = code[j - narg].value;
-              for (int i = j - narg + 1; i < j; i++) {
-                s -= code[i].value;
-              }
-              if (narg == 1) s = -s;
-              currentInstr.value = s;
+              double s = code[instr.childIndex].value;
+              for (int j = 1; j != instr.nArguments; ++j) {
+                s -= code[instr.childIndex + j].value;
+              }
+              if (instr.nArguments == 1) s = -s;
+              instr.value = s;
             }
             break;
           case OpCodes.Mul: {
-              double p = code[j - narg].value;
-              for (int i = j - narg + 1; i < j; i++) {
-                p *= code[i].value;
-              }
-              currentInstr.value = p;
+              double p = code[instr.childIndex].value;
+              for (int j = 1; j != instr.nArguments; ++j) {
+                p *= code[instr.childIndex + j].value;
+              }
+              instr.value = p;
             }
             break;
           case OpCodes.Div: {
-              double p = code[j - narg].value;
-              for (int i = j - narg + 1; i < j; i++) {
-                p /= code[i].value;
-              }
-              if (narg == 1) p = 1.0 / p;
-              currentInstr.value = p;
+              double p = code[instr.childIndex].value;
+              for (int j = 1; j != instr.nArguments; ++j) {
+                p /= code[instr.childIndex + j].value;
+              }
+              if (instr.nArguments == 1) p = 1.0 / p;
+              instr.value = p;
             }
             break;
           case OpCodes.Average: {
-              double sum = code[j - narg].value;
-              for (int i = j - narg + 1; i < j; i++) {
-                sum += code[i].value;
-              }
-              currentInstr.value = sum / narg;
+              double s = code[instr.childIndex].value;
+              for (int j = 1; j != instr.nArguments; ++j) {
+                s += code[instr.childIndex + j].value;
+              }
+              instr.value = s / instr.nArguments;
             }
             break;
           case OpCodes.Cos: {
-              currentInstr.value = Math.Cos(code[j - 1].value);
+              instr.value = Math.Cos(code[instr.childIndex].value);
             }
             break;
           case OpCodes.Sin: {
-              currentInstr.value = Math.Sin(code[j - 1].value);
-              break;
-            }
+              instr.value = Math.Sin(code[instr.childIndex].value);
+            }
+            break;
           case OpCodes.Tan: {
-              currentInstr.value = Math.Tan(code[j - 1].value);
-            }
-            break;
-          case OpCodes.Square: {
-              currentInstr.value = Math.Pow(code[j - 1].value, 2);
-            }
-            break;
-          case OpCodes.Power: {
-              double x = code[j - 2].value;
-              double y = Math.Round(code[j - 1].value);
-              currentInstr.value = Math.Pow(x, y);
-            }
-            break;
-          case OpCodes.SquareRoot: {
-              currentInstr.value = Math.Sqrt(code[j - 1].value);
+              instr.value = Math.Tan(code[instr.childIndex].value);
             }
             break;
           case OpCodes.Root: {
-              double x = code[j - 2].value;
-              double y = Math.Round(code[j - 1].value);
-              currentInstr.value = Math.Pow(x, 1 / y);
+              double x = code[instr.childIndex].value;
+              double y = code[instr.childIndex + 1].value;
+              instr.value = Math.Pow(x, 1 / y);
             }
             break;
           case OpCodes.Exp: {
-              currentInstr.value = Math.Exp(code[j - 1].value);
+              instr.value = Math.Exp(code[instr.childIndex].value);
             }
             break;
           case OpCodes.Log: {
-              currentInstr.value = Math.Log(code[j - 1].value);
+              instr.value = Math.Log(code[instr.childIndex].value);
             }
             break;
           case OpCodes.Gamma: {
-              currentInstr.value = double.IsNaN(code[j - 1].value) ? double.NaN : alglib.gammafunction(code[j - 1].value);
+              var x = code[instr.childIndex].value;
+              instr.value = double.IsNaN(x) ? double.NaN : alglib.gammafunction(x);
             }
             break;
           case OpCodes.Psi: {
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
-              else if (x <= 0 && (Math.Floor(x) - x).IsAlmost(0)) currentInstr.value = double.NaN;
-              else currentInstr.value = alglib.psi(x);
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
+              else if (x <= 0 && (Math.Floor(x) - x).IsAlmost(0)) instr.value = double.NaN;
+              else instr.value = alglib.psi(x);
             }
             break;
           case OpCodes.Dawson: {
-              var x = code[j - 1].value;
-              currentInstr.value = double.IsNaN(x) ? double.NaN : alglib.dawsonintegral(x);
+              var x = code[instr.childIndex].value;
+              instr.value = double.IsNaN(x) ? double.NaN : alglib.dawsonintegral(x);
             }
             break;
           case OpCodes.ExponentialIntegralEi: {
-              var x = code[j - 1].value;
-              currentInstr.value = double.IsNaN(x) ? double.NaN : alglib.exponentialintegralei(x);
+              var x = code[instr.childIndex].value;
+              instr.value = double.IsNaN(x) ? double.NaN : alglib.exponentialintegralei(x);
             }
             break;
           case OpCodes.SineIntegral: {
               double si, ci;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.sinecosineintegrals(x, out si, out ci);
-                currentInstr.value = si;
+                instr.value = si;
               }
             }
@@ -252,9 +301,9 @@
           case OpCodes.CosineIntegral: {
               double si, ci;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.sinecosineintegrals(x, out si, out ci);
-                currentInstr.value = ci;
+                instr.value = si;
               }
             }
@@ -262,9 +311,9 @@
           case OpCodes.HyperbolicSineIntegral: {
               double shi, chi;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.hyperbolicsinecosineintegrals(x, out shi, out chi);
-                currentInstr.value = shi;
+                instr.value = shi;
               }
             }
@@ -272,9 +321,9 @@
           case OpCodes.HyperbolicCosineIntegral: {
               double shi, chi;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.hyperbolicsinecosineintegrals(x, out shi, out chi);
-                currentInstr.value = chi;
+                instr.value = chi;
               }
             }
@@ -282,9 +331,9 @@
           case OpCodes.FresnelCosineIntegral: {
               double c = 0, s = 0;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.fresnelintegral(x, ref c, ref s);
-                currentInstr.value = c;
+                instr.value = c;
               }
             }
@@ -292,9 +341,9 @@
           case OpCodes.FresnelSineIntegral: {
               double c = 0, s = 0;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.fresnelintegral(x, ref c, ref s);
-                currentInstr.value = s;
+                instr.value = s;
               }
             }
@@ -302,9 +351,9 @@
           case OpCodes.AiryA: {
               double ai, aip, bi, bip;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.airy(x, out ai, out aip, out bi, out bip);
-                currentInstr.value = ai;
+                instr.value = ai;
               }
             }
@@ -312,63 +361,73 @@
           case OpCodes.AiryB: {
               double ai, aip, bi, bip;
-              var x = code[j - 1].value;
-              if (double.IsNaN(x)) currentInstr.value = double.NaN;
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
               else {
                 alglib.airy(x, out ai, out aip, out bi, out bip);
-                currentInstr.value = bi;
+                instr.value = bi;
               }
             }
             break;
           case OpCodes.Norm: {
-              var x = code[j - 1].value;
-              currentInstr.value = double.IsNaN(x) ? double.NaN : alglib.normaldistribution(x);
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
+              else instr.value = alglib.normaldistribution(x);
             }
             break;
           case OpCodes.Erf: {
-              var x = code[j - 1].value;
-              currentInstr.value = double.IsNaN(x) ? double.NaN : alglib.errorfunction(x);
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
+              else instr.value = alglib.errorfunction(x);
             }
             break;
           case OpCodes.Bessel: {
-              var x = code[j - 1].value;
-              currentInstr.value = double.IsNaN(x) ? double.NaN : alglib.besseli0(x);
+              var x = code[instr.childIndex].value;
+              if (double.IsNaN(x)) instr.value = double.NaN;
+              else instr.value = alglib.besseli0(x);
             }
             break;
           case OpCodes.IfThenElse: {
-              double condition = code[j - narg].value;
-              double result = condition > 0.0 ? code[j - 2].value : code[j - 1].value;
-              currentInstr.value = result;
+              double condition = code[instr.childIndex].value;
+              double result;
+              if (condition > 0.0) {
+                result = code[instr.childIndex + 1].value;
+              } else {
+                result = code[instr.childIndex + 2].value;
+              }
+              instr.value = result;
             }
             break;
           case OpCodes.AND: {
-              double result = code[j - narg].value;
-              for (int i = j - narg + 1; i < j; i++) {
-                if (result > 0.0) result = code[i].value;
-              }
-              currentInstr.value = result > 0.0 ? 1.0 : -1.0;
+              double result = code[instr.childIndex].value;
+              for (int j = 1; j < instr.nArguments; j++) {
+                if (result > 0.0) result = code[instr.childIndex + j].value;
+                else break;
+              }
+              instr.value = result > 0.0 ? 1.0 : -1.0;
             }
             break;
           case OpCodes.OR: {
-              double result = code[j - narg].value;
-              for (int i = j - narg + 1; i < j; i++) {
-                if (result <= 0.0) result = code[i].value; ;
-              }
-              currentInstr.value = result > 0.0 ? 1.0 : -1.0;
+              double result = code[instr.childIndex].value;
+              for (int j = 1; j < instr.nArguments; j++) {
+                if (result <= 0.0) result = code[instr.childIndex + j].value;
+                else break;
+              }
+              instr.value = result > 0.0 ? 1.0 : -1.0;
             }
             break;
           case OpCodes.NOT: {
-              currentInstr.value = code[j - 1].value > 0.0 ? -1.0 : 1.0;
+              instr.value = code[instr.childIndex].value > 0.0 ? -1.0 : 1.0;
             }
             break;
           case OpCodes.GT: {
-              double x = code[j - 2].value;
-              double y = code[j - 1].value;
-              currentInstr.value = x > y ? 1.0 : -1.0;
+              double x = code[instr.childIndex].value;
+              double y = code[instr.childIndex + 1].value;
+              instr.value = x > y ? 1.0 : -1.0;
             }
             break;
           case OpCodes.LT: {
-              double x = code[j - 2].value;
-              double y = code[j - 1].value;
-              currentInstr.value = x < y ? 1.0 : -1.0;
+              double x = code[instr.childIndex].value;
+              double y = code[instr.childIndex + 1].value;
+              instr.value = x < y ? 1.0 : -1.0;
             }
             break;
@@ -379,56 +438,39 @@
               throw new NotSupportedException();
             }
-
-          //mkommend: derivate calculation taken from: 
-          //http://www.holoborodko.com/pavel/numerical-methods/numerical-derivative/smooth-low-noise-differentiators/
-          //one sided smooth differentiatior, N = 4
-          // y' = 1/8h (f_i + 2f_i-1, -2 f_i-3 - f_i-4)
           case OpCodes.Derivative: {
               throw new NotSupportedException();
             }
-          case OpCodes.Call: {
-              throw new NotSupportedException();
-            }
           case OpCodes.Arg: {
               throw new NotSupportedException();
             }
           case OpCodes.Variable: {
-              if (row < 0 || row >= dataset.Rows) currentInstr.value = double.NaN;
-              else {
-                var variableTreeNode = (VariableTreeNode)currentInstr.dynamicNode;
-                currentInstr.value = ((IList<double>)currentInstr.iArg0)[row] * variableTreeNode.Weight;
-              }
+              if (row < 0 || row >= dataset.Rows) instr.value = double.NaN;
+              var variableTreeNode = (VariableTreeNode)instr.dynamicNode;
+              instr.value = ((IList<double>)instr.iArg0)[row] * variableTreeNode.Weight;
             }
             break;
           case OpCodes.LagVariable: {
-              var laggedVariableTreeNode = (LaggedVariableTreeNode)currentInstr.dynamicNode;
+              var laggedVariableTreeNode = (LaggedVariableTreeNode)instr.dynamicNode;
               int actualRow = row + laggedVariableTreeNode.Lag;
-              if (actualRow < 0 || actualRow >= dataset.Rows) currentInstr.value = double.NaN;
-              else {
-                currentInstr.value = ((IList<double>)currentInstr.iArg0)[actualRow] * laggedVariableTreeNode.Weight;
-              }
+              if (actualRow < 0 || actualRow >= dataset.Rows) instr.value = double.NaN;
+              instr.value = ((IList<double>)instr.iArg0)[actualRow] * laggedVariableTreeNode.Weight;
             }
             break;
           case OpCodes.Constant: {
-              var constTreeNode = (ConstantTreeNode)currentInstr.dynamicNode;
-              currentInstr.value = constTreeNode.Value;
-            }
-            break;
-
-          //mkommend: this symbol uses the logistic function f(x) = 1 / (1 + e^(-alpha * x) ) 
-          //to determine the relative amounts of the true and false branch see http://en.wikipedia.org/wiki/Logistic_function
+              var constTreeNode = (ConstantTreeNode)instr.dynamicNode;
+              instr.value = constTreeNode.Value;
+            }
+            break;
           case OpCodes.VariableCondition: {
-              if (row < 0 || row >= dataset.Rows) currentInstr.value = double.NaN;
-              else {
-                var variableConditionTreeNode = (VariableConditionTreeNode)currentInstr.dynamicNode;
-                double variableValue = ((IList<double>)currentInstr.iArg0)[row];
-                double x = variableValue - variableConditionTreeNode.Threshold;
-                double p = 1 / (1 + Math.Exp(-variableConditionTreeNode.Slope * x));
-
-                double trueBranch = code[j - narg].value;
-                double falseBranch = code[j - narg + 1].value;
-
-                currentInstr.value = trueBranch * p + falseBranch * (1 - p);
-              }
+              if (row < 0 || row >= dataset.Rows) instr.value = double.NaN;
+              var variableConditionTreeNode = (VariableConditionTreeNode)instr.dynamicNode;
+              double variableValue = ((IList<double>)instr.iArg0)[row];
+              double x = variableValue - variableConditionTreeNode.Threshold;
+              double p = 1 / (1 + Math.Exp(-variableConditionTreeNode.Slope * x));
+
+              double trueBranch = code[instr.childIndex].value;
+              double falseBranch = code[instr.childIndex + 1].value;
+
+              instr.value = trueBranch * p + falseBranch * (1 - p);
             }
             break;
@@ -436,17 +478,5 @@
             throw new NotSupportedException();
         }
-
-        // we count the values before the next function is encountered
-        if (narg == 0) { ++count; continue; }
-
-        if (count > narg) {
-          for (int i = 1; i <= count - narg; ++i)
-            code[j - i].value = code[j - i - narg].value;
-        }
-
-        count -= (narg - 1); // because after being evaluated the current instruction becomes a 'value'
       }
-
-      return code[code.Length - 1].value;
     }
   }
Index: branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Plugin.cs.frame
===================================================================
--- branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Plugin.cs.frame	(revision 9292)
+++ branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Plugin.cs.frame	(revision 9732)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
-  [Plugin("HeuristicLab.Problems.DataAnalysis.Symbolic","Provides base classes for symbolic data analysis tasks.", "3.4.3.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.DataAnalysis.Symbolic","Provides base classes for symbolic data analysis tasks.", "3.4.4.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.ALGLIB", "3.6.0")]
+  [PluginDependency("HeuristicLab.ALGLIB", "3.7.0")]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Properties/AssemblyInfo.cs.frame	(revision 9292)
+++ branches/HeuristicLab.DataAnalysis.Symbolic.LinearInterpreter/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Properties/AssemblyInfo.cs.frame	(revision 9732)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -31,5 +31,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2013 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.4.0.0")]
-[assembly: AssemblyFileVersion("3.4.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.4.4.$WCREV$")]
